// #autoload
// #category = AgentABC's Scripts
// #name = ABC TR2 Flag Tracker
// #version = 1.0b
// #date = Sept 30, 2002
// #warrior = AgentABC
// #email = agentabc11@hotmail.com
// #web = http://scripts.tribalwar.com/agent
// #description = Transparent HUD that tracks the flag in TR2
// #status = beta
// #credit = Neofight

package TR2FlagTracker {
	function FTFlagTaken(%msgType, %msgString, %client, %teamname) {
       %name = detag(%client);
        if (StrStr(%msgString, "Teammate") != -1) {
			FTPopup(%name, "has the", "<color:33FF33>");
        }
		else if (StrStr(%msgString, "took the flag!") != -1)
		{
			FTPopup(%name, "has the", "<color:FF3333>");
		}
        else if  (StrStr(%msgString, "You took the flag.") != -1) {
            FTPopup("You", "have the", "<color:33FF33>");
        }
	}
	function FTFlagDropped(%msgType, %msgString, %clientname, %teamName, %team) {
       %name = detag(%clientname);
        if (StrStr(%msgString, "You dropped the flag") != -1) {
             FTPopup("You", "dropped the", "<color:FFAA33>");
        }
        else {
             FTPopup(%name, "dropped the", "<color:FFAA33>");
        }
    }
 	function FTFlagScored(%msgType, %msgString, %clientname, %teamName, %team) {
		%name = detag(%clientname);
        if (StrStr(%msgString, "Your team scored") != -1) {
            %color = "<color:33FF33>";
            %text = %color SPC "Your Team Scored!";
       		FTText.setText("<just:center>"@%text);
        }
		else if (StrStr(%msgString, "You allowed") != -1)
		{
            %color = "<color:FF3333>";
            %text = %color SPC "They Scored :(";
       		FTText.setText("<just:center>"@%text);
		}
	}
  	function FTFlagReSpawn(%msgType, %msgString, %clientname, %teamName, %team) {
        %color = "<color:E9F10A>";
        %text = %color SPC "Flag was placed on top the goal!";

		FTText.setText("<just:center>"@%text);
	}
   	function FTFlagReturned(%msgType, %msgString, %clientname, %teamName, %team) {
        %color =  "<color:E9F10A>";
        %text = %color SPC "Flag was placed in the middle of the map!";

		FTText.setText("<just:center>"@%text);
	}
    // Popup Thingy
    function FTPopup(%clientname, %action, %color) {
		%name = detag(%clientname);
        %teamName = $clTeamScore[%team, 0];
		%text = %clientname SPC %color@%action SPC "flag!";
	
		FTText.setText("<just:center>"@%text);
	}
	function FTClearPopup() {
		FTText.setText("");
	}
	function FTCreate() {
		FTDestroy();
		
		%FlagTrackerX = (getWord($pref::Video::resolution, 0) * 0.5) - 160;
		%FlagTrackerY = getWord($pref::Video::resolution, 1) * 0.73;

		new ShellFieldCtrl(TR2FlagTracker) {
			profile = "GuiConsoleProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = %FlagTrackerX SPC %FlagTrackerY;
			extent = "320 20";
			minExtent = "8 8";
			visible = "1";

			new GuiMLTextCtrl(FTText) {
				profile = "FlagTrackerCtrl";
				horizSizing = "center";
				vertSizing = "center";
				position = "0 0";
				extent = "318 18";
				visible = "1";
				helpTag = "0";
				lineSpacing = "2";
				allowColorChars = "1";
				maxChars = "-1";
			};
		};
		playgui.add(TR2FlagTracker);
	}
	function FTDestroy() {
		if (isObject(TR2FlagTracker)) {
			playGui.remove(TR2FlagTracker);
			TR2FlagTracker.delete();
		}
	}
	function PlayGui::onWake(%this) {
		parent::onWake(%this);
		if (!isObject(TR2FlagTracker)) schedule(3000, 0, "FTCreate");
		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(TR2FlagTracker, "TR2FlagTracker", false);
	}

	function DispatchLaunchMode() {
		addMessageCallback('MsgTR2FlagTaken', FTFlagTaken);
		addMessageCallback('MsgTR2FlagDropped', FTFlagDropped);
  		addMessageCallback('MsgTR2ForcedRespawn', FTFlagReSpawn);
        addMessageCallback('MsgFlagReturned', FTFlagReturned);
		addMessageCallback('msgTR2TeamScored', FTFlagScored);
        addMessageCallback('MsgMissionDropInfo', FTClearPopup);

		parent::DispatchLaunchMode();
	}
};
activatePackage(TR2FlagTracker);
